/**
  * This file was generated from model [Model1] on [Wed May 23 17:51:32 MSD 2007].
  * Do not change content of this file.
  */

import java.io.IOException;
import java.util.*;

import org.apache.commons.lang.BooleanUtils;
import org.apache.commons.lang.math.NumberUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.evelopers.common.exception.*;
import com.evelopers.unimod.core.stateworks.*;
import com.evelopers.unimod.debug.app.AppDebugger;
import com.evelopers.unimod.debug.protocol.JavaSpecificMessageCoder;
import com.evelopers.unimod.runtime.*;
import com.evelopers.unimod.runtime.context.*;
import com.evelopers.unimod.runtime.logger.SimpleLogger;


public class Model1EventProcessor extends AbstractEventProcessor {

	private ModelStructure modelStructure;

				private static final int ADevice = 1;
	
	private int decodeStateMachine(String sm) {
					
		if ("ADevice".equals(sm)) {
			return ADevice;
			}

		return -1;
	}
		
			private ADeviceEventProcessor _ADevice;
		
	public Model1EventProcessor() {
		modelStructure = new Model1ModelStructure();

					_ADevice = new ADeviceEventProcessor();
			}

		    public static void run(int debuggerPort, boolean debuggerSuspend) throws 
						            InterruptedException, EventProcessorException, CommonException, 
        			    IOException {

        		/* Create runtime engine */
        		ModelEngine engine = createModelEngine(true);

		        /* Setup logger */
		        final Log log = LogFactory.getLog(Model1EventProcessor.class);
        		engine.getEventProcessor().addEventProcessorListener(new SimpleLogger(log));

        		/* Setup exception handler */
        		engine.getEventProcessor().addExceptionHandler(new ExceptionHandler() {
		            public void handleException(StateMachineContext context, SystemException e) {
                				log.fatal(e.getChainedMessage(), e.getRootException());
		            }
		        });

        		if (debuggerPort > 0) {
            			AppDebugger d = new AppDebugger(
            					        debuggerPort, debuggerSuspend,
                    					new JavaSpecificMessageCoder(), engine);
                    			d.start();
            		}
            		engine.start();
        	}

    	public static void main(String[] args) throws Exception {
		        int debuggerPort = NumberUtils.stringToInt(System.getProperty("debugger.port"), -1);
        		boolean debuggerSuspend = BooleanUtils.toBoolean(System.getProperty("debugger.suspend"));
        		Model1EventProcessor.run(debuggerPort, debuggerSuspend);
    	}

    	public static ModelEngine createModelEngine(boolean useEventQueue) throws CommonException {
        	ObjectsManager objectsManager = new ObjectsManager();
        	return ModelEngine.createStandAlone(
        		        useEventQueue ? (EventManager) new QueuedHandler() : (EventManager) new StrictHandler(), 
        		        new Model1EventProcessor(),
                objectsManager.getControlledObjectsManager(),
                objectsManager.getEventProvidersManager());
	    }

	    public static class ObjectsManager {
	        private device.ConsoleMechanism o1 = null;
	        private device.MoneyMechanism o2 = null;
	        private device.OutMechanism o3 = null;
	        private device.PrintMechanism o4 = null;
	        private device.ConsoleMechanismEvents p1 = null;
	        private device.MoneyMechanismEvents p3 = null;
	        private device.OutMechanismEvents p2 = null;
	    
	        private ControlledObjectsManager controlledObjectsManager = new ControlledObjectsManagerImpl();
	        private EventProvidersManager eventProvidersManager = new EventProvidersManagerImpl();

	        public ControlledObjectsManager getControlledObjectsManager() {
	            return controlledObjectsManager;
	        }

	        public EventProvidersManager getEventProvidersManager() {
	            return eventProvidersManager;
	        }

	        private class ControlledObjectsManagerImpl implements ControlledObjectsManager {
	            public void init(ModelEngine engine) throws CommonException {}

	            public void dispose() {}

	            public ControlledObject getControlledObject(String coName) {
                if (StringUtils.equals(coName, "o1")) {
                		    if (o1 == null) {
                		        o1 = new device.ConsoleMechanism();
                		    }
                		    return o1;
                }
                if (StringUtils.equals(coName, "o2")) {
                		    if (o2 == null) {
                		        o2 = new device.MoneyMechanism();
                		    }
                		    return o2;
                }
                if (StringUtils.equals(coName, "o3")) {
                		    if (o3 == null) {
                		        o3 = new device.OutMechanism();
                		    }
                		    return o3;
                }
                if (StringUtils.equals(coName, "o4")) {
                		    if (o4 == null) {
                		        o4 = new device.PrintMechanism();
                		    }
                		    return o4;
                }
	                throw new IllegalArgumentException("Controlled object with name [" + coName + "] wasn't found");
	            }
	        }

	        private class EventProvidersManagerImpl implements EventProvidersManager {
	            private List nonameEventProviders = new ArrayList();

	            public void init(ModelEngine engine) throws CommonException {
	                EventProvider ep;
	                ep = getEventProvider("p1");
                ep.init(engine);
	                ep = getEventProvider("p3");
                ep.init(engine);
	                ep = getEventProvider("p2");
                ep.init(engine);
	            }

	            public void dispose() {
	                	EventProvider ep;
		                ep = getEventProvider("p1");
                ep.dispose();
	                ep = getEventProvider("p3");
                ep.dispose();
	                ep = getEventProvider("p2");
                ep.dispose();
                for (Iterator i = nonameEventProviders.iterator(); i.hasNext();) {
                    ep = (EventProvider) i.next();
                    ep.dispose();
                }
            }

	            public EventProvider getEventProvider(String epName) {
	                if (StringUtils.equals(epName, "p1")) {
                		    if (p1 == null) {
                		        p1 = new device.ConsoleMechanismEvents();
                		    }
                		    return p1;
                }
                if (StringUtils.equals(epName, "p3")) {
                		    if (p3 == null) {
                		        p3 = new device.MoneyMechanismEvents();
                		    }
                		    return p3;
                }
                if (StringUtils.equals(epName, "p2")) {
                		    if (p2 == null) {
                		        p2 = new device.OutMechanismEvents();
                		    }
                		    return p2;
                }
                throw new IllegalArgumentException("Event provider with name [" + epName + "] wasn't found");
	            }
	        }
    	}
	
    public ModelStructure getModelStructure() {
		return modelStructure;
	}	
	
    public void setControlledObjectsMap(ControlledObjectsMap controlledObjectsMap) {
        super.setControlledObjectsMap(controlledObjectsMap);
		
					_ADevice.init(controlledObjectsMap);
		    }

	protected StateMachineConfig process(
            Event event, StateMachineContext context,
            StateMachinePath path, StateMachineConfig config) throws SystemException {

		// get state machine from path
		int sm = decodeStateMachine(path.getStateMachine());
		
		try {
		switch (sm) {
					case ADevice:
				return _ADevice.process(event, context, path, config);
					default:
				throw new EventProcessorException("Unknown state machine [" + path.getStateMachine() + "]");
		}
		} catch (Exception e) {
			if (e instanceof SystemException) {
				throw (SystemException)e;
			} else {
				throw new SystemException(e);
			}
		}
	}

    protected StateMachineConfig transiteToStableState(
            StateMachineContext context,
            StateMachinePath path, StateMachineConfig config) throws SystemException {

		// get state machine from path
		int sm = decodeStateMachine(path.getStateMachine());

		try {
		switch (sm) {
					case ADevice:
				return _ADevice.transiteToStableState(context, path, config);
					default:
				throw new EventProcessorException("Unknown state machine [" + path.getStateMachine() + "]");
		}
		} catch (Exception e) {
			if (e instanceof SystemException) {
				throw (SystemException)e;
			} else {
				throw new SystemException(e);
			}
		}
	}	

	
	
private class Model1ModelStructure implements ModelStructure {
	    private Map configManagers = new HashMap();

    private Model1ModelStructure() {
		        configManagers.put("ADevice", new com.evelopers.unimod.runtime.config.DistinguishConfigManager());
		    }

	    public StateMachinePath getRootPath() 
	            throws EventProcessorException {
	        	return new StateMachinePath("ADevice");				
	    }

	    public StateMachineConfigManager getConfigManager(String stateMachine) 
	            throws EventProcessorException {
		        return (StateMachineConfigManager)configManagers.get(stateMachine);
	    }

	    public StateMachineConfig getTopConfig(String stateMachine) 
	            throws EventProcessorException {
        		int sm = decodeStateMachine(stateMachine);
		
		        switch (sm) {
					            case ADevice:
                				return new StateMachineConfig("Top");
					            default:
                				throw new EventProcessorException("Unknown state machine [" + stateMachine + "]");
		        }
	    }

    	public boolean isFinal(String stateMachine, StateMachineConfig config) 
    	        throws EventProcessorException {
		        /* Get state machine from path */
        		int sm = decodeStateMachine(stateMachine);
        		int state;
		        		switch (sm) {
					            case ADevice:
                				state = _ADevice.decodeState(config.getActiveState());
				                switch (state) {
																																																																                    case ADeviceEventProcessor.s2:
																																				                        return true;
				                    					default:
                    						    return false;
                	}
					            default:
                				throw new EventProcessorException("Unknown state machine [" + stateMachine + "]");
		        }
	    }			
}
	
			







private class ADeviceEventProcessor {

		// states
	    private static final int Top = 1;
	    private static final int _2___________ = 2;
	    private static final int _1____ = 3;
	    private static final int s1 = 4;
	    private static final int _6____ = 5;
	    private static final int s2 = 6;
	    private static final int _4______ = 7;
	    private static final int _5_____ = 8;
	
	private int decodeState(String state) {
					
		if ("Top".equals(state)) {
			return Top;
						} else 
				
		if ("2.       .  ".equals(state)) {
			return _2___________;
						} else 
				
		if ("1.   ".equals(state)) {
			return _1____;
						} else 
				
		if ("s1".equals(state)) {
			return s1;
						} else 
				
		if ("6.   ".equals(state)) {
			return _6____;
						} else 
				
		if ("s2".equals(state)) {
			return s2;
						} else 
				
		if ("4.     ".equals(state)) {
			return _4______;
						} else 
				
		if ("5.    ".equals(state)) {
			return _5_____;
			}
		
		return -1;
	}
	
		// events
	    private static final int e4 = 1;
	    private static final int e2 = 2;
	    private static final int e7 = 3;
	    private static final int e5 = 4;
	    private static final int e1 = 5;
	    private static final int e3 = 6;
	    private static final int e6 = 7;
	
	private int decodeEvent(String event) {
					
		if ("e4".equals(event)) {
			return e4;
						} else 
				
		if ("e2".equals(event)) {
			return e2;
						} else 
				
		if ("e7".equals(event)) {
			return e7;
						} else 
				
		if ("e5".equals(event)) {
			return e5;
						} else 
				
		if ("e1".equals(event)) {
			return e1;
						} else 
				
		if ("e3".equals(event)) {
			return e3;
						} else 
				
		if ("e6".equals(event)) {
			return e6;
				}
	
		return -1;
	}
		
							private device.ConsoleMechanism o1;
								private device.MoneyMechanism o2;
								private device.OutMechanism o3;
								private device.PrintMechanism o4;
				
	private void init(ControlledObjectsMap controlledObjectsMap) {
									o1 = (device.ConsoleMechanism)controlledObjectsMap.getControlledObject("o1");
												o2 = (device.MoneyMechanism)controlledObjectsMap.getControlledObject("o2");
												o3 = (device.OutMechanism)controlledObjectsMap.getControlledObject("o3");
												o4 = (device.PrintMechanism)controlledObjectsMap.getControlledObject("o4");
						}
		
	private StateMachineConfig process(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
		config = lookForTransition(event, context, path, config);
		
		config = transiteToStableState(context, path, config);
		
		// execute included state machines
		executeSubmachines(event, context, path, config);
		
		return config;
	}
	
	private void executeSubmachines(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
		int state = decodeState(config.getActiveState());
		
		while (true) {
		switch (state) {
																			case _2___________: 
					
											return;
																					case _1____: 
					
											return;
																					case s1: 
					
											return;
																					case _6____: 
					
											return;
																					case s2: 
					
											return;
																					case _4______: 
					
											return;
																					case _5_____: 
					
											return;
																default:
					throw new EventProcessorException("State with name [" + config.getActiveState() + "] is unknown for state machine [ADevice]");
		}
		}
	}
	
	private StateMachineConfig transiteToStableState(StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {

		int s = decodeState(config.getActiveState());
		Event event;

		switch (s) {
									case Top:
					
										
					fireComeToState(context, path, "s1");

					// s1->1.    [true]/
					event = Event.NO_EVENT;
						fireTransitionFound(context, path, "s1", event, "s1#1.   ##true");
	
		
	fireComeToState(context, path, "1.   ");
	
	// 1.    [o1.z1, o2.z2]
				fireBeforeOutputActionExecution(context, path, "s1#1.   ##true", "o1.z1");

				o1.z1(context);
		
	fireAfterOutputActionExecution(context, path, "s1#1.   ##true", "o1.z1");
				fireBeforeOutputActionExecution(context, path, "s1#1.   ##true", "o2.z2");

				o2.z2(context);
		
	fireAfterOutputActionExecution(context, path, "s1#1.   ##true", "o2.z2");
						
											return new StateMachineConfig("1.   ");
																																															}
	
		return config;
	}    
	
	private StateMachineConfig lookForTransition(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
					
		
			boolean
								
			o2_x3 = false
									,
						
			o2_x2 = false
				;
				
		
			int
								
			o1_x1 = 0
									,
						
			o4_x4 = 0
				;
	
				BitSet calculatedInputActions = new BitSet(4);
		
		int s = decodeState(config.getActiveState());
		int e = decodeEvent(event.getName());
	
		while (true) {
			switch (s) {
																			case _2___________:
						
											
												switch (e) {
													case e4:
																
						// 2.       .  ->1.    e4[o1.x1 == 0]/
			
			fireTransitionCandidate(context, path, "2.       .  ", event, "2.       .  #1.   #e4#o1.x1 == 0");
			
																	if (!isInputActionCalculated(calculatedInputActions, _o1_x1)) {
	
		fireBeforeInputActionExecution(context, path, "2.       .  #1.   #e4#o1.x1 == 0", "o1.x1");

					o1_x1 = o1.x1(context);

			fireAfterInputActionExecution(context, path, "2.       .  #1.   #e4#o1.x1 == 0", "o1.x1", new Integer(o1_x1));
			}					
							
							
			
												if (o1_x1 == 0) {
				
					fireTransitionFound(context, path, "2.       .  ", event, "2.       .  #1.   #e4#o1.x1 == 0");
	
		
	fireComeToState(context, path, "1.   ");
	
	// 1.    [o1.z1, o2.z2]
				fireBeforeOutputActionExecution(context, path, "2.       .  #1.   #e4#o1.x1 == 0", "o1.z1");

				o1.z1(context);
		
	fireAfterOutputActionExecution(context, path, "2.       .  #1.   #e4#o1.x1 == 0", "o1.z1");
				fireBeforeOutputActionExecution(context, path, "2.       .  #1.   #e4#o1.x1 == 0", "o2.z2");

				o2.z2(context);
		
	fireAfterOutputActionExecution(context, path, "2.       .  #1.   #e4#o1.x1 == 0", "o2.z2");
					return new StateMachineConfig("1.   ");

									}
												// 2.       .  ->6.    e4[o1.x1 != 0]/
			
			fireTransitionCandidate(context, path, "2.       .  ", event, "2.       .  #6.   #e4#o1.x1 != 0");
			
													
							
			
												if (o1_x1 != 0) {
				
					fireTransitionFound(context, path, "2.       .  ", event, "2.       .  #6.   #e4#o1.x1 != 0");
	
		
	fireComeToState(context, path, "6.   ");
	
	// 6.    [o1.z8, o3.z2, o2.z2]
				fireBeforeOutputActionExecution(context, path, "2.       .  #6.   #e4#o1.x1 != 0", "o1.z8");

				o1.z8(context);
		
	fireAfterOutputActionExecution(context, path, "2.       .  #6.   #e4#o1.x1 != 0", "o1.z8");
				fireBeforeOutputActionExecution(context, path, "2.       .  #6.   #e4#o1.x1 != 0", "o3.z2");

				o3.z2(context);
		
	fireAfterOutputActionExecution(context, path, "2.       .  #6.   #e4#o1.x1 != 0", "o3.z2");
				fireBeforeOutputActionExecution(context, path, "2.       .  #6.   #e4#o1.x1 != 0", "o2.z2");

				o2.z2(context);
		
	fireAfterOutputActionExecution(context, path, "2.       .  #6.   #e4#o1.x1 != 0", "o2.z2");
					return new StateMachineConfig("6.   ");

									}
																
										// transition not found
								return config;
																			case e2:
																
						// 2.       .  ->2.       .   e2[!o2.x2 && (!o2.x3)]/o1.z6
			
			fireTransitionCandidate(context, path, "2.       .  ", event, "2.       .  #2.       .  #e2#!o2.x2 && (!o2.x3)");
			
																	if (!isInputActionCalculated(calculatedInputActions, _o2_x3)) {
	
		fireBeforeInputActionExecution(context, path, "2.       .  #2.       .  #e2#!o2.x2 && (!o2.x3)", "o2.x3");

					o2_x3 = o2.x3(context);
		
			fireAfterInputActionExecution(context, path, "2.       .  #2.       .  #e2#!o2.x2 && (!o2.x3)", "o2.x3", new Boolean(o2_x3));
			}					
																		if (!isInputActionCalculated(calculatedInputActions, _o2_x2)) {
	
		fireBeforeInputActionExecution(context, path, "2.       .  #2.       .  #e2#!o2.x2 && (!o2.x3)", "o2.x2");

					o2_x2 = o2.x2(context);
		
			fireAfterInputActionExecution(context, path, "2.       .  #2.       .  #e2#!o2.x2 && (!o2.x3)", "o2.x2", new Boolean(o2_x2));
			}					
							
							
			
												if (!o2_x2 && !o2_x3) {
				
					fireTransitionFound(context, path, "2.       .  ", event, "2.       .  #2.       .  #e2#!o2.x2 && (!o2.x3)");
	
				fireBeforeOutputActionExecution(context, path, "2.       .  #2.       .  #e2#!o2.x2 && (!o2.x3)", "o1.z6");

				o1.z6(context);
		
	fireAfterOutputActionExecution(context, path, "2.       .  #2.       .  #e2#!o2.x2 && (!o2.x3)", "o1.z6");
		
	fireComeToState(context, path, "2.       .  ");
	
	// 2.       .   [o1.z2, o2.z1]
				fireBeforeOutputActionExecution(context, path, "2.       .  #2.       .  #e2#!o2.x2 && (!o2.x3)", "o1.z2");

				o1.z2(context);
		
	fireAfterOutputActionExecution(context, path, "2.       .  #2.       .  #e2#!o2.x2 && (!o2.x3)", "o1.z2");
				fireBeforeOutputActionExecution(context, path, "2.       .  #2.       .  #e2#!o2.x2 && (!o2.x3)", "o2.z1");

				o2.z1(context);
		
	fireAfterOutputActionExecution(context, path, "2.       .  #2.       .  #e2#!o2.x2 && (!o2.x3)", "o2.z1");
					return new StateMachineConfig("2.       .  ");

									}
												// 2.       .  ->2.       .   e2[o2.x2]/o2.z3,o1.z7
			
			fireTransitionCandidate(context, path, "2.       .  ", event, "2.       .  #2.       .  #e2#o2.x2");
			
													
							
			
												if (o2_x2) {
				
					fireTransitionFound(context, path, "2.       .  ", event, "2.       .  #2.       .  #e2#o2.x2");
	
				fireBeforeOutputActionExecution(context, path, "2.       .  #2.       .  #e2#o2.x2", "o2.z3");

				o2.z3(context);
		
	fireAfterOutputActionExecution(context, path, "2.       .  #2.       .  #e2#o2.x2", "o2.z3");
				fireBeforeOutputActionExecution(context, path, "2.       .  #2.       .  #e2#o2.x2", "o1.z7");

				o1.z7(context);
		
	fireAfterOutputActionExecution(context, path, "2.       .  #2.       .  #e2#o2.x2", "o1.z7");
		
	fireComeToState(context, path, "2.       .  ");
	
	// 2.       .   [o1.z2, o2.z1]
				fireBeforeOutputActionExecution(context, path, "2.       .  #2.       .  #e2#o2.x2", "o1.z2");

				o1.z2(context);
		
	fireAfterOutputActionExecution(context, path, "2.       .  #2.       .  #e2#o2.x2", "o1.z2");
				fireBeforeOutputActionExecution(context, path, "2.       .  #2.       .  #e2#o2.x2", "o2.z1");

				o2.z1(context);
		
	fireAfterOutputActionExecution(context, path, "2.       .  #2.       .  #e2#o2.x2", "o2.z1");
					return new StateMachineConfig("2.       .  ");

									}
												// 2.       .  ->4.      e2[!o2.x2 && (o2.x3)]/
			
			fireTransitionCandidate(context, path, "2.       .  ", event, "2.       .  #4.     #e2#!o2.x2 && (o2.x3)");
			
																				
							
			
												if (!o2_x2 && o2_x3) {
				
					fireTransitionFound(context, path, "2.       .  ", event, "2.       .  #4.     #e2#!o2.x2 && (o2.x3)");
	
		
	fireComeToState(context, path, "4.     ");
	
	// 4.      [o1.z6, o1.z3, o2.z2]
				fireBeforeOutputActionExecution(context, path, "2.       .  #4.     #e2#!o2.x2 && (o2.x3)", "o1.z6");

				o1.z6(context);
		
	fireAfterOutputActionExecution(context, path, "2.       .  #4.     #e2#!o2.x2 && (o2.x3)", "o1.z6");
				fireBeforeOutputActionExecution(context, path, "2.       .  #4.     #e2#!o2.x2 && (o2.x3)", "o1.z3");

				o1.z3(context);
		
	fireAfterOutputActionExecution(context, path, "2.       .  #4.     #e2#!o2.x2 && (o2.x3)", "o1.z3");
				fireBeforeOutputActionExecution(context, path, "2.       .  #4.     #e2#!o2.x2 && (o2.x3)", "o2.z2");

				o2.z2(context);
		
	fireAfterOutputActionExecution(context, path, "2.       .  #4.     #e2#!o2.x2 && (o2.x3)", "o2.z2");
					return new StateMachineConfig("4.     ");

									}
																
										// transition not found
								return config;
																		default:
														
							
										// transition not found
								return config;
												}
						
																						case _1____:
						
											
												switch (e) {
													case e1:
																
						// 1.   ->2.       .   e1[true]/
			
			fireTransitionCandidate(context, path, "1.   ", event, "1.   #2.       .  #e1#true");
			
						
							
			
							
					fireTransitionFound(context, path, "1.   ", event, "1.   #2.       .  #e1#true");
	
		
	fireComeToState(context, path, "2.       .  ");
	
	// 2.       .   [o1.z2, o2.z1]
				fireBeforeOutputActionExecution(context, path, "1.   #2.       .  #e1#true", "o1.z2");

				o1.z2(context);
		
	fireAfterOutputActionExecution(context, path, "1.   #2.       .  #e1#true", "o1.z2");
				fireBeforeOutputActionExecution(context, path, "1.   #2.       .  #e1#true", "o2.z1");

				o2.z1(context);
		
	fireAfterOutputActionExecution(context, path, "1.   #2.       .  #e1#true", "o2.z1");
					return new StateMachineConfig("2.       .  ");

																				
														case e6:
																
						// 1.   ->s2 e6[true]/
			
			fireTransitionCandidate(context, path, "1.   ", event, "1.   #s2#e6#true");
			
						
							
			
							
					fireTransitionFound(context, path, "1.   ", event, "1.   #s2#e6#true");
	
		
	fireComeToState(context, path, "s2");
	
	// s2 []
					return new StateMachineConfig("s2");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																													case _6____:
						
											
												switch (e) {
													case e7:
																
						// 6.   ->1.    e7[true]/
			
			fireTransitionCandidate(context, path, "6.   ", event, "6.   #1.   #e7#true");
			
						
							
			
							
					fireTransitionFound(context, path, "6.   ", event, "6.   #1.   #e7#true");
	
		
	fireComeToState(context, path, "1.   ");
	
	// 1.    [o1.z1, o2.z2]
				fireBeforeOutputActionExecution(context, path, "6.   #1.   #e7#true", "o1.z1");

				o1.z1(context);
		
	fireAfterOutputActionExecution(context, path, "6.   #1.   #e7#true", "o1.z1");
				fireBeforeOutputActionExecution(context, path, "6.   #1.   #e7#true", "o2.z2");

				o2.z2(context);
		
	fireAfterOutputActionExecution(context, path, "6.   #1.   #e7#true", "o2.z2");
					return new StateMachineConfig("1.   ");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																													case _4______:
						
											
												switch (e) {
													case e4:
																
						// 4.     ->1.    e4[o1.x1 == 0]/
			
			fireTransitionCandidate(context, path, "4.     ", event, "4.     #1.   #e4#o1.x1 == 0");
			
																	if (!isInputActionCalculated(calculatedInputActions, _o1_x1)) {
	
		fireBeforeInputActionExecution(context, path, "4.     #1.   #e4#o1.x1 == 0", "o1.x1");

					o1_x1 = o1.x1(context);

			fireAfterInputActionExecution(context, path, "4.     #1.   #e4#o1.x1 == 0", "o1.x1", new Integer(o1_x1));
			}					
							
							
			
												if (o1_x1 == 0) {
				
					fireTransitionFound(context, path, "4.     ", event, "4.     #1.   #e4#o1.x1 == 0");
	
		
	fireComeToState(context, path, "1.   ");
	
	// 1.    [o1.z1, o2.z2]
				fireBeforeOutputActionExecution(context, path, "4.     #1.   #e4#o1.x1 == 0", "o1.z1");

				o1.z1(context);
		
	fireAfterOutputActionExecution(context, path, "4.     #1.   #e4#o1.x1 == 0", "o1.z1");
				fireBeforeOutputActionExecution(context, path, "4.     #1.   #e4#o1.x1 == 0", "o2.z2");

				o2.z2(context);
		
	fireAfterOutputActionExecution(context, path, "4.     #1.   #e4#o1.x1 == 0", "o2.z2");
					return new StateMachineConfig("1.   ");

									}
												// 4.     ->6.    e4[o1.x1 != 0]/
			
			fireTransitionCandidate(context, path, "4.     ", event, "4.     #6.   #e4#o1.x1 != 0");
			
													
							
			
												if (o1_x1 != 0) {
				
					fireTransitionFound(context, path, "4.     ", event, "4.     #6.   #e4#o1.x1 != 0");
	
		
	fireComeToState(context, path, "6.   ");
	
	// 6.    [o1.z8, o3.z2, o2.z2]
				fireBeforeOutputActionExecution(context, path, "4.     #6.   #e4#o1.x1 != 0", "o1.z8");

				o1.z8(context);
		
	fireAfterOutputActionExecution(context, path, "4.     #6.   #e4#o1.x1 != 0", "o1.z8");
				fireBeforeOutputActionExecution(context, path, "4.     #6.   #e4#o1.x1 != 0", "o3.z2");

				o3.z2(context);
		
	fireAfterOutputActionExecution(context, path, "4.     #6.   #e4#o1.x1 != 0", "o3.z2");
				fireBeforeOutputActionExecution(context, path, "4.     #6.   #e4#o1.x1 != 0", "o2.z2");

				o2.z2(context);
		
	fireAfterOutputActionExecution(context, path, "4.     #6.   #e4#o1.x1 != 0", "o2.z2");
					return new StateMachineConfig("6.   ");

									}
																
										// transition not found
								return config;
																			case e3:
																
						// 4.     ->5.     e3[true]/
			
			fireTransitionCandidate(context, path, "4.     ", event, "4.     #5.    #e3#true");
			
						
							
			
							
					fireTransitionFound(context, path, "4.     ", event, "4.     #5.    #e3#true");
	
		
	fireComeToState(context, path, "5.    ");
	
	// 5.     [o1.z4, o3.z1, o3.z2]
				fireBeforeOutputActionExecution(context, path, "4.     #5.    #e3#true", "o1.z4");

				o1.z4(context);
		
	fireAfterOutputActionExecution(context, path, "4.     #5.    #e3#true", "o1.z4");
				fireBeforeOutputActionExecution(context, path, "4.     #5.    #e3#true", "o3.z1");

				o3.z1(context);
		
	fireAfterOutputActionExecution(context, path, "4.     #5.    #e3#true", "o3.z1");
				fireBeforeOutputActionExecution(context, path, "4.     #5.    #e3#true", "o3.z2");

				o3.z2(context);
		
	fireAfterOutputActionExecution(context, path, "4.     #5.    #e3#true", "o3.z2");
					return new StateMachineConfig("5.    ");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																						case _5_____:
						
											
												switch (e) {
													case e5:
																
						// 5.    ->1.    e5[o4.x4 > 1]/o4.z1
			
			fireTransitionCandidate(context, path, "5.    ", event, "5.    #1.   #e5#o4.x4 > 1");
			
																	if (!isInputActionCalculated(calculatedInputActions, _o4_x4)) {
	
		fireBeforeInputActionExecution(context, path, "5.    #1.   #e5#o4.x4 > 1", "o4.x4");

					o4_x4 = o4.x4(context);

			fireAfterInputActionExecution(context, path, "5.    #1.   #e5#o4.x4 > 1", "o4.x4", new Integer(o4_x4));
			}					
							
							
			
												if (o4_x4 > 1) {
				
					fireTransitionFound(context, path, "5.    ", event, "5.    #1.   #e5#o4.x4 > 1");
	
				fireBeforeOutputActionExecution(context, path, "5.    #1.   #e5#o4.x4 > 1", "o4.z1");

				o4.z1(context);
		
	fireAfterOutputActionExecution(context, path, "5.    #1.   #e5#o4.x4 > 1", "o4.z1");
		
	fireComeToState(context, path, "1.   ");
	
	// 1.    [o1.z1, o2.z2]
				fireBeforeOutputActionExecution(context, path, "5.    #1.   #e5#o4.x4 > 1", "o1.z1");

				o1.z1(context);
		
	fireAfterOutputActionExecution(context, path, "5.    #1.   #e5#o4.x4 > 1", "o1.z1");
				fireBeforeOutputActionExecution(context, path, "5.    #1.   #e5#o4.x4 > 1", "o2.z2");

				o2.z2(context);
		
	fireAfterOutputActionExecution(context, path, "5.    #1.   #e5#o4.x4 > 1", "o2.z2");
					return new StateMachineConfig("1.   ");

									}
												// 5.    ->s2 e5[o4.x4 <= 1]/o1.z9,o2.z2
			
			fireTransitionCandidate(context, path, "5.    ", event, "5.    #s2#e5#o4.x4 <= 1");
			
													
							
			
												if (o4_x4 <= 1) {
				
					fireTransitionFound(context, path, "5.    ", event, "5.    #s2#e5#o4.x4 <= 1");
	
				fireBeforeOutputActionExecution(context, path, "5.    #s2#e5#o4.x4 <= 1", "o1.z9");

				o1.z9(context);
		
	fireAfterOutputActionExecution(context, path, "5.    #s2#e5#o4.x4 <= 1", "o1.z9");
				fireBeforeOutputActionExecution(context, path, "5.    #s2#e5#o4.x4 <= 1", "o2.z2");

				o2.z2(context);
		
	fireAfterOutputActionExecution(context, path, "5.    #s2#e5#o4.x4 <= 1", "o2.z2");
		
	fireComeToState(context, path, "s2");
	
	// s2 []
					return new StateMachineConfig("s2");

									}
																
										// transition not found
								return config;
																		default:
														
							
										// transition not found
								return config;
												}
						
																	default:
					throw new EventProcessorException("Incorrect stable state [" + config.getActiveState() + "] in state machine [ADevice]");
			}
		}
	}

				//o2.x3
				private static final int _o2_x3 = 0;
			//o1.x1
				private static final int _o1_x1 = 1;
			//o4.x4
				private static final int _o4_x4 = 2;
			//o2.x2
				private static final int _o2_x2 = 3;
	        
}
	
	private static boolean isInputActionCalculated(BitSet calculatedInputActions, int k) {
		boolean b = calculatedInputActions.get(k);
            
        if (!b) {
			calculatedInputActions.set(k);
		}
            
        return b;
	}
	
}
	
