/**
  * This file was generated from model [Model1] on [Wed May 23 17:51:31 MSD 2007].
  * Do not change content of this file.
  */

#include "Model1ModelEngine.h"

CModel1ModelEngine* CModel1ModelEngine::NewL(
        device.ConsoleMechanism* aO1,
        device.MoneyMechanism* aO2,
        device.OutMechanism* aO3,
        device.PrintMechanism* aO4)
    {
    CModel1ModelEngine* self = CModel1ModelEngine::NewLC(
        aO1, aO2, aO3, aO4); 
	CleanupStack::Pop(self);
    return self;
    }

CModel1ModelEngine* CModel1ModelEngine::NewLC(
        device.ConsoleMechanism* aO1,
        device.MoneyMechanism* aO2,
        device.OutMechanism* aO3,
        device.PrintMechanism* aO4)
    {
    CModel1ModelEngine* self = new (ELeave) CModel1ModelEngine;
    CleanupStack::PushL(self);
    self->ConstructL(
        aO1, aO2, aO3, aO4); 
    return self;
    }

void CModel1ModelEngine::ConstructL(
        device.ConsoleMechanism* aO1,
        device.MoneyMechanism* aO2,
        device.OutMechanism* aO3,
        device.PrintMechanism* aO4)
	{
	iADevice = new (ELeave) TADevice(*this);

	iADevice->SetO1(aO1);
	iADevice->SetO2(aO2);
	iADevice->SetO3(aO3);
	iADevice->SetO4(aO4);
	}

CModel1ModelEngine::~CModel1ModelEngine()
	{
	if (iADevice)
		{
		delete iADevice;
		iADevice = NULL;
		}
	}

/*
 * Returns name of the given event
 */
const TDesC& CModel1ModelEngine::EventName(CModel1ModelEngine::EEvent anEvent) const
	{
	switch (anEvent)
	    {
	    case E1:
			{
			_LIT(KEventName, "e1");
		    return KEventName;
			}
	    case E2:
			{
			_LIT(KEventName, "e2");
		    return KEventName;
			}
	    case E3:
			{
			_LIT(KEventName, "e3");
		    return KEventName;
			}
	    case E4:
			{
			_LIT(KEventName, "e4");
		    return KEventName;
			}
	    case E5:
			{
			_LIT(KEventName, "e5");
		    return KEventName;
			}
	    case E6:
			{
			_LIT(KEventName, "e6");
		    return KEventName;
			}
	    case E7:
			{
			_LIT(KEventName, "e7");
		    return KEventName;
			}

        default:
			{
			_LIT(KEventName, "*");
			return KEventName;
			}
		}
	}

void CModel1ModelEngine::HandleL(CModel1ModelEngine::EEvent aEvent)
	{
	iADevice->HandleL(aEvent, iContext);
	}
void CModel1BaseMachine::DoLogL(TDesC& message)
	{
	TBuf8<128> message8;
	message8.Copy(message);
	iModel.Log()->WriteL(message8);
	iModel.Log()->CommitL();
	}

void CModel1BaseMachine::LogBeginL(const TDesC& aStateName, CAutoAnswererModelEngine::EEvent aEvent)
	{
	_LIT(KFormat, "%S:[%S] on %S\n");
	TBuf<128> message;
	message.Format(KFormat, &MachineName(), &aStateName, &iModel.EventName(aEvent));
	DoLogL(message);
	}
	
void CModel1BaseMachine::LogTransiteL(const TDesC& aOldStateName, const TDesC& aNewStateName)
	{
	_LIT(KFormat, "  %S:[%S] => [%S]\n");
	TBuf<128> message;
	message.Format(KFormat, &MachineName(), &aOldStateName, &aNewStateName);
	DoLogL(message);
	}
	
void CModel1BaseMachine::LogEndL(const TDesC& aStateName, CAutoAnswererModelEngine::EEvent /*aEvent*/)
	{
	_LIT(KFormat, "%S:[%S]\n\n");
	TBuf<128> message;
	message.Format(KFormat, &MachineName(), &aStateName);
	DoLogL(message);
	}
	
void CModel1BaseMachine::LogActionBeginL(const TDesC& anIdentifier)
	{
	_LIT(KFormat, "  %S {\n");
	TBuf<128> message;
	message.Format(KFormat, &anIdentifier);
	DoLogL(message);
	}
	
void CModel1BaseMachine::LogActionEndL(const TDesC& anIdentifier)
	{
	_LIT(KFormat, "  %S }\n");
	TBuf<128> message;
	message.Format(KFormat, &anIdentifier);
	DoLogL(message);
	}
	
void CModel1BaseMachine::LogActionEndL(const TDesC& anIdentifier, TInt aValue)
	{
	_LIT(KFormat, "  %S = %d }\n");
	TBuf<128> message;
	message.Format(KFormat, &anIdentifier, aValue);
	DoLogL(message);
	}


///////////////////////////////////////////////////////////////////////////
// Automaton ADevice section
///////////////////////////////////////////////////////////////////////////

/*
 * Executes on enter actions of the given state of automaton ADevice
 */
void TADevice::EnterStateL(TADevice::EState aState, TStateMachineContext& aContext)
	{
	switch (aState)
	    {
	    case A1__:
            iO1->Z1L(aContext);
            iO2->Z2L(aContext);
			break;
	    case A2________:
            iO1->Z2L(aContext);
            iO2->Z1L(aContext);
			break;
	    case S2:
			break;
	    case A4____:
            iO1->Z6L(aContext);
            iO1->Z3L(aContext);
            iO2->Z2L(aContext);
			break;
	    case A5___:
            iO1->Z4L(aContext);
            iO3->Z1L(aContext);
            iO3->Z2L(aContext);
			break;
	    case A6__:
            iO1->Z8L(aContext);
            iO3->Z2L(aContext);
            iO2->Z2L(aContext);
			break;
	    case TOP:
			break;
		}
	}

/*
 * Checks whether given state of automaton ADevice is stable.
 */
TBool TADevice::IsStable(TADevice::EState aState) const
	{
	return 
        aState == TADevice::EState::A1__ ||
        aState == TADevice::EState::A2________ ||
        aState == TADevice::EState::S2 ||
        aState == TADevice::EState::A4____ ||
        aState == TADevice::EState::A5___ ||
        aState == TADevice::EState::A6__ ||
        FALSE;
	}

/*
 * Returns superstate of the given state of automaton ADevice
 */
const TDesC& TADevice::StateName(TADevice::EState aState) const
	{
	switch (aState)
	    {
	    case A1__:
			{
			_LIT(KStateName, "1.   ");
		    return KStateName;
			}
	    case A2________:
			{
			_LIT(KStateName, "2.       .  ");
		    return KStateName;
			}
	    case S2:
			{
			_LIT(KStateName, "s2");
		    return KStateName;
			}
	    case A4____:
			{
			_LIT(KStateName, "4.     ");
		    return KStateName;
			}
	    case A5___:
			{
			_LIT(KStateName, "5.    ");
		    return KStateName;
			}
	    case A6__:
			{
			_LIT(KStateName, "6.   ");
		    return KStateName;
			}
	    case TOP:
			{
			_LIT(KStateName, "Top");
		    return KStateName;
			}
        default:
			{
			_LIT(KStateName, "<<Unknown>>");
			return KStateName;
			}
		}
	}

/*
 * Returns name of the machine
 */
const TDesC& TADevice::MachineName() const
	{
	_LIT(KName, "ADevice");
    return KName;
	}

/*
 * Returns superstate of the given state of automaton ADevice
 */
TADevice::EState TADevice::GetSuperstate(TADevice::EState aState) const
	{
	switch (aState)
	    {
	    case A1__:
		    return TOP;
	    case A2________:
		    return TOP;
	    case S2:
		    return TOP;
	    case A4____:
		    return TOP;
	    case A5___:
		    return TOP;
	    case A6__:
		    return TOP;
        default:
			// For top and unexisting states
			return UNKNOWN_STATE;
		}
	}

/*
 * For stable state immediately returns itself. For unstable state transites
 * to corresponding stable invoking all actions on transitions.
 */
TADevice::EState TADevice::TransiteToStableL(TADevice::EState aState, TStateMachineContext& aContext)
    {	
	EState newState = aState;
	while (!IsStable(newState)) 
        {
		switch (newState)
		    {
            case TOP:				
                newState = A1__;
                LogTransiteL(StateName(S1), StateName(newState));
                EnterStateL(newState, aContext);
			    break;
			default: ;// Impossible case
			}
        }
	return newState;
	}

/*
 * Selects transition and transites.
 */
TADevice::EState TADevice::TransiteOnEventL(CModel1ModelEngine::EEvent aEvent, TStateMachineContext& aContext)
	{
	TADevice::EState targetState = UNKNOWN_STATE;
	for (TADevice::EState sourceState = iState; targetState == UNKNOWN_STATE && sourceState != TOP; sourceState = GetSuperstate(sourceState))
		{
        switch (sourceState) 
    	    {
            /* State: 1.    */
            case A1__:
                switch (aEvent)
    			    {
					case CModel1ModelEngine::EEvent::E1:
                        targetState = A2________;
                        LogTransiteL(StateName(A1__), StateName(targetState));
                        EnterStateL(targetState, aContext);
	                    break;
					case CModel1ModelEngine::EEvent::E6:
                        targetState = S2;
                        LogTransiteL(StateName(A1__), StateName(targetState));
                        EnterStateL(targetState, aContext);
	                    break;
                    default: ;// Do nothing if no event was triggered
					}
			    break;
            /* State: 2.       .   */
            case A2________:
                switch (aEvent)
    			    {
					case CModel1ModelEngine::EEvent::E2:
	                    if (!iO2->X2L(aContext) && !iO2->X3L(aContext))
						    {
                            iO1->Z6L(aContext);
                            targetState = A2________;
                            LogTransiteL(StateName(A2________), StateName(targetState));
                            EnterStateL(targetState, aContext);
						    }
                        else
	                    if (iO2->X2L(aContext))
						    {
                            iO2->Z3L(aContext);
                            iO1->Z7L(aContext);
                            targetState = A2________;
                            LogTransiteL(StateName(A2________), StateName(targetState));
                            EnterStateL(targetState, aContext);
						    }
                        else
	                    if (!iO2->X2L(aContext) && iO2->X3L(aContext))
						    {
                            targetState = A4____;
                            LogTransiteL(StateName(A2________), StateName(targetState));
                            EnterStateL(targetState, aContext);
						    }
	                    break;
					case CModel1ModelEngine::EEvent::E4:
	                    if (iO1->X1L(aContext) == 0)
						    {
                            targetState = A1__;
                            LogTransiteL(StateName(A2________), StateName(targetState));
                            EnterStateL(targetState, aContext);
						    }
                        else
	                    if (iO1->X1L(aContext) != 0)
						    {
                            targetState = A6__;
                            LogTransiteL(StateName(A2________), StateName(targetState));
                            EnterStateL(targetState, aContext);
						    }
	                    break;
                    default: ;// Do nothing if no event was triggered
					}
			    break;
            /* State: s2 */
            case S2:
                switch (aEvent)
    			    {
                    default: ;// Do nothing if no event was triggered
					}
			    break;
            /* State: 4.      */
            case A4____:
                switch (aEvent)
    			    {
					case CModel1ModelEngine::EEvent::E3:
                        targetState = A5___;
                        LogTransiteL(StateName(A4____), StateName(targetState));
                        EnterStateL(targetState, aContext);
	                    break;
					case CModel1ModelEngine::EEvent::E4:
	                    if (iO1->X1L(aContext) == 0)
						    {
                            targetState = A1__;
                            LogTransiteL(StateName(A4____), StateName(targetState));
                            EnterStateL(targetState, aContext);
						    }
                        else
	                    if (iO1->X1L(aContext) != 0)
						    {
                            targetState = A6__;
                            LogTransiteL(StateName(A4____), StateName(targetState));
                            EnterStateL(targetState, aContext);
						    }
	                    break;
                    default: ;// Do nothing if no event was triggered
					}
			    break;
            /* State: 5.     */
            case A5___:
                switch (aEvent)
    			    {
					case CModel1ModelEngine::EEvent::E5:
	                    if (iO4->X4L(aContext) > 1)
						    {
                            iO4->Z1L(aContext);
                            targetState = A1__;
                            LogTransiteL(StateName(A5___), StateName(targetState));
                            EnterStateL(targetState, aContext);
						    }
                        else
	                    if (iO4->X4L(aContext) <= 1)
						    {
                            iO1->Z9L(aContext);
                            iO2->Z2L(aContext);
                            targetState = S2;
                            LogTransiteL(StateName(A5___), StateName(targetState));
                            EnterStateL(targetState, aContext);
						    }
	                    break;
                    default: ;// Do nothing if no event was triggered
					}
			    break;
            /* State: 6.    */
            case A6__:
                switch (aEvent)
    			    {
					case CModel1ModelEngine::EEvent::E7:
                        targetState = A1__;
                        LogTransiteL(StateName(A6__), StateName(targetState));
                        EnterStateL(targetState, aContext);
	                    break;
                    default: ;// Do nothing if no event was triggered
					}
			    break;
            /* State: Top */
            case TOP:
                switch (aEvent)
    			    {
                    default: ;// Do nothing if no event was triggered
					}
			    break;
			}
		}
		
	// Look for default transition
	for (TADevice::EState sourceState = iState; targetState == UNKNOWN_STATE && sourceState != TOP; sourceState = GetSuperstate(sourceState))
		{
        switch (sourceState) 
    	    {
            /* State: 1.    */
            case A1__:
			    break;
            /* State: 2.       .   */
            case A2________:
			    break;
            /* State: s2 */
            case S2:
			    break;
            /* State: 4.      */
            case A4____:
			    break;
            /* State: 5.     */
            case A5___:
			    break;
            /* State: 6.    */
            case A6__:
			    break;
            /* State: Top */
            case TOP:
			    break;
			}
		}
	
	// If no transition was found stay in current state
	return targetState != UNKNOWN_STATE ? targetState : iState;
	}

void TADevice::InvokeSubmachinesL(CModel1ModelEngine::EEvent aEvent, TStateMachineContext& aContext)
	{
	for (EState curState = iState; curState != TOP; curState = GetSuperstate(curState))
		{
        switch (curState)
    	    {
            /* State: 1.    */
            case A1__:
			    break;
            /* State: 2.       .   */
            case A2________:
			    break;
            /* State: s2 */
            case S2:
			    break;
            /* State: 4.      */
            case A4____:
			    break;
            /* State: 5.     */
            case A5___:
			    break;
            /* State: 6.    */
            case A6__:
			    break;
            /* State: Top */
            case TOP:
			    break;
			}
		}
	}

void TADevice::HandleL(CModel1ModelEngine::EEvent aEvent, TStateMachineContext& aContext)
	{
	// Init state machine ADevice if it is in its top state
	if (iState == EState::TOP) 
		{
		iState = TransiteToStableL(EState::TOP, aContext);
		}
	
	LogBeginL(StateName(iState), aEvent);
	EState newState = TransiteOnEventL(aEvent, aContext);
	iState = TransiteToStableL(newState, aContext);
	InvokeSubmachinesL(aEvent, aContext);
	LogEndL(StateName(iState), aEvent);
	}

